<?php
/**
 * EDUtwitter: Block for Moodle 2.2.1
 * 
 * 
 * @package  EDUtwitter
 * @author   David Romero Santos <david.romerosantos@alum.uca.es>
 * @license  http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link     https://forja.rediris.es/projects/cusl6-edutweets/
 */

class block_edutwitter_edit_form extends block_edit_form {
    
    protected function specific_definition($mform) {

        global $COURSE;

        $mform->addElement('header', 'configheader', get_string('blocksettings', 'block'));

        // add name on Twitter
        $mform->addElement('text', 'config_name', get_string('name', 'block_edutwitter'));
        $mform->setDefault('config_name', '');
        $mform->setType('config_name', PARAM_MULTILANG);

        // add consumer key
        $mform->addElement('text', 'config_consumerkey', get_string('consumerkey', 'block_edutwitter'));
        $mform->setDefault('config_consumerkey', '');
        $mform->setType('config_consumerkey', PARAM_MULTILANG);

        // add consumer secret key
        $mform->addElement('text', 'config_consumersecret', get_string('consumersecret', 'block_edutwitter'));
        $mform->setDefault('config_consumersecret', '');
        $mform->setType('config_consumersecret', PARAM_MULTILANG);

        // add access token
        $mform->addElement('text', 'config_oauthtoken', get_string('oauthtoken', 'block_edutwitter'));
        $mform->setDefault('config_oauthtoken', '');
        $mform->setType('config_oauthtoken', PARAM_MULTILANG);

        // add access token secret
        $mform->addElement('text', 'config_oauthsecret', get_string('oauthsecret', 'block_edutwitter'));
        $mform->setDefault('config_oauthsecret', '');
        $mform->setType('config_oauthsecret', PARAM_MULTILANG);
        
        // add hashtag
        $mform->addElement('text', 'config_search_term', get_string('search_term', 'block_edutwitter'));
        $mform->setDefault('config_search_term', 'moodle');
        $mform->setType('config_search_term', PARAM_MULTILANG);

        // add a button hashtags generator
        $button = $mform->addElement('button', 'config_ghashtag', get_string('ghashtag', 'block_edutwitter'));
        $buttonattributes = array('onclick'=>'function random_number(lower,upper){ number = Math.floor(Math.random()*(upper-lower))+lower; return number;} function random_char(){ var lower="abcdefghijklmnopqrstuvwxyz"; var upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ"; var charset=""; charset+=lower; charset+=upper; character=charset.charAt(random_number(0,charset.length)); return character;} function generate(){ var hashtag="'.$COURSE->idnumber.'"; hashtag+=random_char(); return hashtag;} mform1.id_config_search_term.value = generate();');
        $button->updateAttributes($buttonattributes);

        // add a button hashtags checker
        $button = $mform->addElement('button', 'config_chashtag', get_string('chashtag', 'block_edutwitter'));
        $buttonattributes = array('onclick'=>'if(mform1.id_config_search_term.value.charAt(0) == "#"){ var hashtag=mform1.id_config_search_term.value; }else{  var hashtag = "#"; hashtag+=mform1.id_config_search_term.value;} hashtag = hashtag.replace("#","3"); var url = "https://twitter.com/search?q=%2"; url+=hashtag; window.open(url, "Comprobación del hashtag");');
        $button->updateAttributes($buttonattributes);

        // add a language selector for Twitter
        $mform->addElement('select', 'config_language', get_string('language', 'block_edutwitter'), array (get_string('english', 'block_edutwitter'), get_string('spanish', 'block_edutwitter')));
        $mform->setDefault('config_language', get_string('english', 'block_edutwitter'));
        $mform->setType('config_language', PARAM_MULTILANG);

        // add number of tweets
        $mform->addElement('select', 'config_numtweets', get_string('numtweets', 'block_edutwitter'), range(1, 20));
        $mform->setDefault('config_numtweets', 2);
        $mform->setType('config_numtweets', PARAM_INT);

        // add show names
        $mform->addElement('advcheckbox', 'config_show_names', get_string('show_names', 'block_edutwitter'));
        $mform->setDefault('config_show_names', true);
        $mform->setType('config_show_names', PARAM_BOOL);

        // add show usernames
        $mform->addElement('advcheckbox', 'config_show_usernames', get_string('show_usernames', 'block_edutwitter'));
        $mform->setDefault('config_show_usernames', true);
        $mform->setType('config_show_usernames', PARAM_BOOL);
       
        // add show images
        $mform->addElement('advcheckbox', 'config_show_images', get_string('show_images', 'block_edutwitter'));
        $mform->setDefault('config_show_images', true);
        $mform->setType('config_show_images', PARAM_BOOL);

        // add send tweets with recent activity
        $mform->addElement('advcheckbox', 'config_recent_activity', get_string('recent_activity', 'block_edutwitter'));
        $mform->setDefault('config_recent_activity', true);
        $mform->setType('config_recent_activity', PARAM_BOOL);

        // add generate statistics
        $mform->addElement('advcheckbox', 'config_statistics', get_string('statistics', 'block_edutwitter'));
        $mform->setDefault('config_statistics', true);
        $mform->setType('config_statistics', PARAM_BOOL);

        // add courseid
        $mform->addElement('hidden', 'config_course', get_string('course', 'block_edutwitter'));
        $mform->setDefault('config_course', $COURSE->id);
        $mform->setType('config_course', PARAM_INT);
    }
}
