<?php
/**
 * EDUtwitter: Block for Moodle 2.2.1
 * 
 * 
 * @package  EDUtwitter
 * @author   David Romero Santos <david.romerosantos@alum.uca.es>
 * @license  http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link     https://forja.rediris.es/projects/cusl6-edutweets/
 */

require_once("{$CFG->libdir}/formslib.php");

class sendtweet_form extends moodleform {

    function definition() {
    
        $mform =& $this->_form;

        // add group for text areas
        $mform->addElement('header','displayinfo', get_string('textfields','block_edutwitter'));
        
        // add check for hashtag
        $mform->addElement('selectyesno', 'displaypicture', get_string('displaypicture', 'block_edutwitter'));
        $mform->setDefault('displaypicture', 1);

        // add tweet field
        $mform->addElement('textarea', 'tweet', get_string('tweet', 'block_edutwitter'), 'rows="4" cols="50"');
        $mform->addRule('tweet', null, 'maxlength', 250, 'client');
        $mform->addRule('tweet', null, 'required', null, 'client');

        // hidden elements
        $mform->addElement('hidden', 'blockid');
        $mform->addElement('hidden', 'courseid');
        $mform->addElement('hidden', 'consumerkey');
        $mform->addElement('hidden', 'consumersecret');
        $mform->addElement('hidden', 'oauthtoken');
        $mform->addElement('hidden', 'oauthsecret');
        $mform->addElement('hidden', 'search_term');

        $this->add_action_buttons();
    }
}
?>
