<?php
/**
 * EDUtwitter: Block for Moodle 2.2.1
 * 
 * 
 * @package  EDUtwitter
 * @author   David Romero Santos <david.romerosantos@alum.uca.es>
 * @license  http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link     https://forja.rediris.es/projects/cusl6-edutweets/
 */

require_once('../../config.php');
require_once('sendtweet_form.php');
require_once('TwitterAPIExchange.php');
require_once('split_tweet.php');

global $DB, $OUTPUT, $PAGE;

// Check for all required variables.
$courseid = required_param('courseid', PARAM_INT);

$blockid = required_param('blockid', PARAM_INT);

$consumerkey = required_param('consumerkey', PARAM_MULTILANG);

$consumersecret = required_param('consumersecret', PARAM_MULTILANG);

$oauthtoken = required_param('oauthtoken', PARAM_MULTILANG);

$oauthsecret = required_param('oauthsecret', PARAM_MULTILANG);

$search_term = required_param('search_term', PARAM_MULTILANG);

//Next look for optional variables.
$id = optional_param('id', 0, PARAM_INT);

if (!$course = $DB->get_record('course', array('id' => $courseid))) {
    print_error('invalidcourse', 'block_edutwitter', $courseid);
}

require_login($course);

$PAGE->set_url('/blocks/edutwitter/view_sendtweet.php', array('id' => $courseid));
$PAGE->set_pagelayout('standard');
$PAGE->set_heading(get_string('edithtml', 'block_edutwitter'));

$settingsnode = $PAGE->settingsnav->add(get_string('edutwittersettings', 'block_edutwitter'));
$editurl = new moodle_url('/blocks/edutwitter/view_sendtweet.php', array('id' => $id, 'courseid' => $courseid, 'blockid' => $blockid));
$editnode = $settingsnode->add(get_string('editpage', 'block_edutwitter'), $editurl);
$editnode->make_active(); 


$edutwitter = new sendtweet_form();

$toform['blockid'] = $blockid;
$toform['courseid'] = $courseid;
$toform['consumerkey'] = $consumerkey;
$toform['consumersecret'] = $consumersecret;
$toform['oauthtoken'] = $oauthtoken;
$toform['oauthsecret'] = $oauthsecret;
$toform['search_term'] = $search_term;
$edutwitter->set_data($toform);

if($search_term[0] != '#'){
        $hashtag = '#'.$search_term;
        $search_term=$hashtag;
}

if($edutwitter->is_cancelled()) {
    //Cancelled forms redirect to the course main page.
    $courseurl = new moodle_url('/course/view.php', array('id' => $courseid));
    redirect($courseurl);
} else if ($fromform = $edutwitter->get_data()) {
    $courseurl = new moodle_url('/course/view.php', array('id' => $courseid));
    /**
    * Send the tweet
    */
    if($fromform->displaypicture){
        if($search_term[0] == '#'){
            $contenido = $search_term . " " . $fromform->tweet;
        } else {
            $contenido = '#'.$search_term . " " . $fromform->tweet;
        }
    } else {
        $contenido = $fromform->tweet;
    }
    $settings = array('oauth_access_token' => $oauthtoken, 'oauth_access_token_secret' => $oauthsecret, 'consumer_key' => $consumerkey, 'consumer_secret' => $consumersecret);
    $url = 'https://api.twitter.com/1.1/statuses/update.json';
    $requestMethod = 'POST';
    $postfields = array('status' => $contenido); 
    $tweet = new TwitterAPIExchange($settings);
    $response = $tweet->buildOauth($url, $requestMethod)
                      ->setPostfields($postfields)
                      ->performRequest();
    $salida = json_decode($response);
    if(!empty($salida->errors)){
        foreach($salida->errors as $error){
            if($error->code == '186'){
                split_tweet($tweet,$contenido);
            }
        }
    }
    redirect($courseurl);
} else {
    //form did not validate or this is the first display
    $site = get_site();
    echo $OUTPUT->header();
    $edutwitter->display();
    echo $OUTPUT->footer();
}

?>
