<?php
/**
 * EDUtwitter: Block for Moodle 2.2.1
 * 
 * 
 * @package  EDUtwitter
 * @author   David Romero Santos <david.romerosantos@alum.uca.es>
 * @license  http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link     https://forja.rediris.es/projects/cusl6-edutweets/
 */

require_once('../../config.php');
require_once('submit_form.php');

global $DB, $OUTPUT, $PAGE, $USER;

//Check for all required variables.
$courseid = required_param('courseid', PARAM_INT);
$blockid = required_param('blockid', PARAM_INT);

//Next look for optional variables.
$id = optional_param('id', 0, PARAM_INT);

if (!$course = $DB->get_record('course', array('id' => $courseid))){
    print_error('invalidcourse', 'block_edutwitter', $courseid);
}

require_login($course);

$PAGE->set_url('/blocks/edutwitter/view_submit.php', array('id' => $courseid));
$PAGE->set_pagelayout('standard');
$PAGE->set_heading(get_string('edithtml', 'block_edutwitter'));

$settingsnode = $PAGE->settingsnav->add(get_string('edutwittersettings', 'block_edutwitter'));
$editurl = new moodle_url('/blocks/edutwitter/view_submit.php', array('id' => $id, 'courseid' => $courseid, 'blockid' => $blockid));
$editnode = $settingsnode->add(get_string('editpage_submit', 'block_edutwitter'), $editurl);
$editnode->make_active();

$submit = new submit_form();

$toform['blockid'] = $blockid;
$toform['courseid'] = $courseid;
$submit->set_data($toform);

if($submit->is_cancelled()) {
    //Cancelled forms redirect to the course main page
    $courseurl = new moodle_url('/course/view.php', array('id' => $courseid));
    redirect($courseurl);
} else if ($fromform = $submit->get_data()) {
    /**
    * Register the username on Twitter of the student in the database
    */
    $courseurl = new moodle_url('/course/view.php', array('id' => $courseid));
    $record = new stdClass();
    $record->userid = $USER->id;
    $record->username = $USER->firstname;
    $record->userlast = $USER->lastname;
    $record->twitteruser = $fromform->pagetitle_submit;
    $record->courseid = $courseid;
    $record->list_twitter = '0';
    if($DB->record_exists('block_edutwitter_users', array('userid'=>$USER->id, 'courseid'=>$courseid))){
        $record = $DB->get_record('block_edutwitter_users', array('userid'=>$USER->id));
        $record->twitteruser = $fromform->pagetitle_submit;
        $DB->update_record('block_edutwitter_users', $record);
    } else {
        if(!$DB->insert_record('block_edutwitter_users',$record)){
            print_error('inserterror', 'block_edutwitter_users');
        }
    }
    redirect($courseurl);
} else {
    // form didn't validate or this is the first display
    $site = get_site();
    echo $OUTPUT->header();
    $submit->display();
    echo $OUTPUT->footer();
}

?>
